{-# LANGUAGE QuasiQuotes #-}
{-# LANGUAGE TemplateHaskell #-}

module Core.Templates ( renderIndex, renderStyle ) where

import Text.Blaze.Html.Renderer.Text (renderHtml)
import Text.Blaze.Html
import Text.Cassius                  (cassiusFile, renderCss)
import Text.Hamlet                   (shamletFile)

import qualified Data.Text      as T
import qualified Data.Text.Lazy as LT

import Prelude 

renderIndex :: String -> Maybe T.Text -> LT.Text
renderIndex link password = renderHtml ( $(shamletFile "./views/index.hamlet") )

renderStyle :: LT.Text
renderStyle = renderCss ( $(cassiusFile "./views/cassius/style.cassius") "/style.css" )
