module Feature.Generation.Links ( genLink ) where

import Core.Types
import Feature.Generation.Shared (rIndex)

import Control.Monad.Reader (ask, lift, liftIO)
import Data.Char (toLower, toUpper)
import Data.List (foldl')
import System.IO
import System.Random

genLink :: Int -> [Char] -> IO [Char]
genLink 0 cs = return cs
genLink d cs = do 
  res <- rChar
  fin <- rCap res
  genLink (d - 1) (cs <> (fin:[]))

validChars :: [Char]
validChars = ['a'..'z'] <> ['1'..'9']

rChar :: IO Char
rChar = rIndex validChars

rCap :: Char -> IO Char -- rCap takes a single character and returns it
rCap c = do             -- capitalized or lowercased at random.
  capRand <- randomRIO (0,1)
  return $ checkRand capRand c
    where
      checkRand :: Int -> Char -> Char
      checkRand r c 
        | r == 0 = toLower c
        | r == 1 = toUpper c
        | otherwise = c  
